use std::collections::HashMap;
use std::sync::Arc;
use tokio::net::TcpStream;
use crate::app::UserApp;
use crate::master::Master;
use tokio::runtime::Runtime;
use tokio::sync::Mutex;
use crate::listener::WsListener;

pub struct MasterMgr {
    curr_context_id: i64,
    mastersvr_hash: HashMap<i32, Master>,
    tokio_rt: Runtime,
}


impl MasterMgr {


    pub fn instance() -> &'static Self {
        return &UserApp::instance()._masterMgr;
    }

    pub fn new() -> Self {
        let p = Self{
            curr_context_id: 0,
            mastersvr_hash: Default::default(),
            tokio_rt: tokio::runtime::Builder::new_multi_thread()
                .enable_all()
                .build()
                .unwrap(),
        };
        return p;
    }

    pub fn init(&self) {
        self.tokio_rt.spawn(async move {
            let mut result = TcpStream::connect("192.168.100.39:7616").await;
            match result {
                Ok(v) => {
                    let a = Arc::new(Mutex::new(v));
                    //WsListener::instance().upstream.lock().unwrap().replace(a.clone());
                    println!("connect ok");
                    //crate::listener::wslistener::upstream_enter(a, down_pack_queue, up_pack_queue).await;
                },
                Err(e) => {
                    println!("connect err")
                }
            }
        });
    }

    pub fn uninit(&self) {

    }

}